/*
 * Copyright (c) 2016, Charlie Kwon, redisGate.com <redisgate at gmail dot com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *   * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of Redis nor the names of its contributors may be used
 *     to endorse or promote products derived from this software without
 *     specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * 한글 BSD 라이선스
 *
 * 저작권 (c) 2016, 권대욱 <redisgate@gmail.com>, redisGate.com
 * All rights reserved.
 *
 * 소스코드와 바이너리 형태의 재배포와 사용은 수정 여부와 관계없이
 * 다음 조건을 충족할 때 가능하다.
 * 
 *   * 소스코드를 재배포하기 위해서는 반드시 위의 저작권 표시, 지금 보이는 조건들과 
 *     다음과 같은 면책조항을 유지하여야만 한다.
 *   * 바이너리 형태의 재배포는 배포판과 함께 제공되는 문서 또는 다른 형태로 위의 저작권 표시,
 *     지금 보이는 조건들과 다음과 같은 면책조항을 명시해야 한다.
 *   * 사전 서면 승인 없이는 저자의 이름이나 기여자들의 이름을 이 소프트웨어로부터 파생된
 *     제품을 보증하거나 홍보할 목적으로 사용할 수 없다.
 *
 * 본 SW는 저작권자와 기여자들에 의해 "있는 그대로" 제공될 뿐이며, 상품가치나 특정한 목적에
 * 부합하는 묵시적 보증을 포함하여(단, 이에 제한되지 않음), 어떠한 형태의 보증도 하지 않는다.
 * 어떠한 경우에도 재단과 기여자들은 제품이나 서비스의 대체 조달, 또는 데이터, 이윤, 사용상의
 * 손해, 업무의 중단 등을 포함하여(단, 이에 제한되지 않음), 본 소프트웨어를 사용함으로써 발생한
 * 직접적이거나, 간접적 또는 우연적이거나, 특수하거나, 전형적이거나, 결과적인 피해에 대해,
 * 계약에 의한 것이든, 엄격한 책임, 불법행위(또는 과실 및 기타 행위를 포함)에 의한 것이든, 이와
 * 여타 책임 소재에 상관없이, 또한 그러한 손해의 가능이 예견되어 있었다 하더라도 전혀 책임을
 * 지지 않는다.
 *
 */

/* Users: 사용자 login id, password, loginCnt, admin를 관리한다.
 */
typedef struct users {
	sds id;		/* userid */
	sds pw;		/* password */
	int loginCnt; 			/* login count for some period */
	int admin;				/* admin user 1, others 0 */
	int loginFailCnt; 	/* Login fail count */
	time_t lastLoginTime;	/* Last login time(Unix timestamp) */
} users;

typedef struct _userSortObject {
	char userid[20];
	users *user;
} userSortObject;

int loadUsers();
int saveUsers();

char *bfcrypt(const char *key);
int strSortCmp(const void *s1, const void *s2);

